// delete table
function did_click_table_remove_button(event)
{
    if ( ! bridge_is_available() )
        return;
    
    Bridge.didClickTableRemoveButton(bridge_id_for_node(event.target))
}

// delete day header
function did_click_day_remove_button(event)
{
    if ( ! bridge_is_available() )
        return;
    
    Bridge.didClickDayRemoveButton(bridge_id_for_node(event.target))

    if (event.stopPropagation)
    {
        event.stopPropagation();
    }
}

// edit day header using calendar widget
function open_date_picker_panel(event)
{
    if ( ! bridge_is_available() )
        return;
    
    gutter_icon_div = event.target
    gutter_div = gutter_icon_div.parentNode
    var paragraph = gutter_div.parentNode
    var container_body = paragraph.parentNode
    var container = container_body.parentNode
    var p = paragraph.getElementsByTagName('p')[0]
    
    var id = bridge_id_for_node(p)
    Bridge.openDatePickerPanel()
    
    if (event.stopPropagation)
    {
        event.stopPropagation();
    }
}

// click on the checkmark icon --> toggle between 2 styles of bullets if we have a paragraph of class `bullet`
function did_click_gutter_checkmark(event)
{
    if (Bridge.isExperiment() != 'YES')
    {
        return;
    }
    
    var gutter_icon_div = event.target
    var gutter_div = gutter_icon_div.parentNode
    
    var paragraph = gutter_div.parentNode
    var container_body = paragraph.parentNode
    var container = container_body.parentNode
    var p = paragraph.getElementsByTagName('p')[0]
    
    if ( ! p.className.match(/bullet|number|normal|code/) )
        return
        
        // current state = done --> change to not done
        if ( p.className.match(/done/) ) {
            p_class = p.className.replace('done','')
            p_class = p_class.replace('  ',' ')
            p.className = p_class
            gutter_icon_div.setAttribute('title', 'Mark as done')
        }
    
    // current state = not done --> change to done
        else {
            p.className = p.className + ' done'
            gutter_icon_div.setAttribute('title', 'Unmark as done')
        }
    
    if ( bridge_is_available() ) {
        Bridge.didClickCheckmark(bridge_id_for_node(event.target))
    }
}


// timestamp / stopwatch / timer
// all handled on the ObjC side

function did_click_gutter_timestamp(event)
{
    Bridge.didClickTimestampStart(bridge_id_for_node(event.target))
}

function did_click_gutter_timestamp_stop(event)
{
    Bridge.didClickTimestampStop(bridge_id_for_node(event.target))
}

function did_click_gutter_timer(event)
{
    Bridge.didClickCountdownTimer(bridge_id_for_node(event.target))
}

function did_click_gutter_gear(event)
{
    Bridge.didClickTimerSettings(bridge_id_for_node(event.target))
}

function did_click_gutter_timer_start(event)
{
    Bridge.didClickTimerStart(bridge_id_for_node(event.target))
}

function did_click_gutter_timer_pause(event)
{
    Bridge.didClickTimerPause(bridge_id_for_node(event.target))
}

function did_click_gutter_timer_resume(event)
{
    Bridge.didClickTimerResume(bridge_id_for_node(event.target))
}

function did_click_gutter_timer_delete(event)
{
    Bridge.didClickTimerDelete(bridge_id_for_node(event.target))
}

function did_click_gutter_text()
{
    Bridge.didClickTimerText(bridge_id_for_node(event.target))
}

